// A fan game by poret. This game is not affiliated with SNK. This is a fan game which is not being sold or distributed for profit.

#include "Game/KOFDefaultGameMode.h"

#include "Kismet/GameplayStatics.h"

AKOFDefaultGameMode::AKOFDefaultGameMode()
{
	NumCharactersPerTeam = 3;

	Gravity = 1000;
	MaxAllowedDistanceFromOpponent = 700;
	StageLength = 2400;
	StartY = 150;
}

void AKOFDefaultGameMode::InitTeams()
{
	for (TSubclassOf<AKOFBaseCharacter> CharacterTemplate : P1TeamTemplate)
	{
		AKOFBaseCharacter* Temp = GetWorld()->SpawnActor<AKOFBaseCharacter>(CharacterTemplate);
		Temp->SetIsPossessedByPlayer1(true);
		Temp->Init();
		if(Temp)
		{
			P1Team.Add(Temp);
		}
	}
	
	for (TSubclassOf<AKOFBaseCharacter> CharacterTemplate : P2TeamTemplate)
	{
		AKOFBaseCharacter* Temp = GetWorld()->SpawnActor<AKOFBaseCharacter>(CharacterTemplate);
		Temp->SetIsPossessedByPlayer1(false);
		Temp->Init();
		if(Temp)
		{
			P2Team.Add(Temp);
		}
	}
}

void AKOFDefaultGameMode::StartPlay()
{
	Super::StartPlay();

	InitTeams();

	// is this the right place to do this?
	APlayerController* PC1 = UGameplayStatics::GetPlayerController(GetWorld(), 0);
	if(PC1)
	{
		AKOFBaseCharacter* P1 = GetP1CurrentCharacter();
		if(P1)
		{
			PC1->Possess(P1);
		}
	}

	APlayerController* PC2 = UGameplayStatics::GetPlayerController(GetWorld(), 1);
	if(PC2)
	{
		AKOFBaseCharacter* P2 = GetP1CurrentCharacter();
		if(P2)
		{
			PC2->Possess(P2);
		}
	}
}
